/* Copyright (C) logi.cals GmbH. All rights reserved. */

/*
** TASK      :: Nameserver Definition Table
** NOTES     ::
*/

/***************************************************************************
** Global Includes, Defines , Types
****************************************************************************/
#include <RTNameServer.h>
#include <RTSSIOGeneric.h>
#include <RTIODriverParam.h>
#include <NSTimeStamp.h>
#include <lcpu___program1.h>


#ifndef ARR_EL_CNT
#define ARR_EL_CNT(arr) (sizeof(arr)/sizeof(arr[0]))
#endif

char const* ns_getrevision(void)
{
  return LC_NS_TIMESTAMP;
}

static struct _struct_ns_naddress s_paddress_list[] = {
  {1,0,0,0},
  {1,70,0,0},
  {1,70,1,0},
  {1,70,2,0},
  {1,70,3,0},
  {1,70,4,0},
  {1,70,5,0},
  {1,70,6,0},
  {1,70,7,0},
  {1,70,8,0},
  {1,70,9,0},
  {1,70,10,0},
  {1,70,11,0},
  {1,70,12,0},
  {1,70,13,0},
  {0,0,0,0}
};

#define LCNS_PHYS_ADDR_STR___I_1 "%IX1.0.0"
#define LCNS_PHYS_ADDR_STR___O_1 "%QX1.70.0"
#define LCNS_PHYS_ADDR_STR___O_2 "%QX1.70.1"
#define LCNS_PHYS_ADDR_STR___O_3 "%QX1.70.2"
#define LCNS_PHYS_ADDR_STR___O_4 "%QX1.70.3"
#define LCNS_PHYS_ADDR_STR___O_5 "%QX1.70.4"
#define LCNS_PHYS_ADDR_STR___O_6 "%QX1.70.5"
#define LCNS_PHYS_ADDR_STR___O_7 "%QX1.70.6"
#define LCNS_PHYS_ADDR_STR___O_8 "%QX1.70.7"
#define LCNS_PHYS_ADDR_STR___O_9 "%QX1.70.8"
#define LCNS_PHYS_ADDR_STR___O_10 "%QX1.70.9"
#define LCNS_PHYS_ADDR_STR___O_11 "%QX1.70.10"
#define LCNS_PHYS_ADDR_STR___O_12 "%QX1.70.11"
#define LCNS_PHYS_ADDR_STR___O_13 "%QX1.70.12"
#define LCNS_PHYS_ADDR_STR___O_14 "%QX1.70.13"

#define LCNS_PHYS_ADDR_NUM___I_1 (s_paddress_list + 0)
#define LCNS_PHYS_ADDR_NUM___O_1 (s_paddress_list + 1)
#define LCNS_PHYS_ADDR_NUM___O_2 (s_paddress_list + 2)
#define LCNS_PHYS_ADDR_NUM___O_3 (s_paddress_list + 3)
#define LCNS_PHYS_ADDR_NUM___O_4 (s_paddress_list + 4)
#define LCNS_PHYS_ADDR_NUM___O_5 (s_paddress_list + 5)
#define LCNS_PHYS_ADDR_NUM___O_6 (s_paddress_list + 6)
#define LCNS_PHYS_ADDR_NUM___O_7 (s_paddress_list + 7)
#define LCNS_PHYS_ADDR_NUM___O_8 (s_paddress_list + 8)
#define LCNS_PHYS_ADDR_NUM___O_9 (s_paddress_list + 9)
#define LCNS_PHYS_ADDR_NUM___O_10 (s_paddress_list + 10)
#define LCNS_PHYS_ADDR_NUM___O_11 (s_paddress_list + 11)
#define LCNS_PHYS_ADDR_NUM___O_12 (s_paddress_list + 12)
#define LCNS_PHYS_ADDR_NUM___O_13 (s_paddress_list + 13)
#define LCNS_PHYS_ADDR_NUM___O_14 (s_paddress_list + 14)

#define LCNS_IO_FLAG___I_1 2
#define LCNS_IO_FLAG___O_1 2
#define LCNS_IO_FLAG___O_2 2
#define LCNS_IO_FLAG___O_3 2
#define LCNS_IO_FLAG___O_4 2
#define LCNS_IO_FLAG___O_5 2
#define LCNS_IO_FLAG___O_6 2
#define LCNS_IO_FLAG___O_7 2
#define LCNS_IO_FLAG___O_8 2
#define LCNS_IO_FLAG___O_9 2
#define LCNS_IO_FLAG___O_10 2
#define LCNS_IO_FLAG___O_11 2
#define LCNS_IO_FLAG___O_12 2
#define LCNS_IO_FLAG___O_13 2
#define LCNS_IO_FLAG___O_14 2


#define LCNS_TNREF___LAUFLICHT (s_type_nodes + 1)
#define LCNS_TNREF___PROGRAM1 (s_type_nodes + 0)
#define LCNS_TNREF___RS (s_type_nodes + 2)
#define LCNS_TNREF___R_TRIG (s_type_nodes + 3)
#define LCNS_TNREF___TON (s_type_nodes + 4)
#define LCNS_TNREF___VAR_GLOBAL (s_type_nodes + 5)

extern const RTTypeNS_TypeNode s_type_nodes[];

#if LCNS_EL_CNT___VAR_GLOBAL
static const RTTypeNS_ElementNode s_element_nodes_VAR_GLOBAL[] = LCNS_EL_INI___VAR_GLOBAL;
#else
#define s_element_nodes_VAR_GLOBAL NULL
#endif
#if LCNS_EL_CNT___LAUFLICHT
static const RTTypeNS_ElementNode s_element_nodes_LAUFLICHT[] = LCNS_EL_INI___LAUFLICHT;
#else
#define s_element_nodes_LAUFLICHT NULL
#endif
#if LCNS_EL_CNT___PROGRAM1
static const RTTypeNS_ElementNode s_element_nodes_PROGRAM1[] = LCNS_EL_INI___PROGRAM1;
#else
#define s_element_nodes_PROGRAM1 NULL
#endif
#if LCNS_EL_CNT___RS
static const RTTypeNS_ElementNode s_element_nodes_RS[] = LCNS_EL_INI___RS;
#else
#define s_element_nodes_RS NULL
#endif
#if LCNS_EL_CNT___R_TRIG
static const RTTypeNS_ElementNode s_element_nodes_R_TRIG[] = LCNS_EL_INI___R_TRIG;
#else
#define s_element_nodes_R_TRIG NULL
#endif
#if LCNS_EL_CNT___TON
static const RTTypeNS_ElementNode s_element_nodes_TON[] = LCNS_EL_INI___TON;
#else
#define s_element_nodes_TON NULL
#endif


const RTTypeNS_TypeNode s_type_nodes[] = {
{ sizeof(RTTypeNS_TypeNode),"Program1_PROGRAM1",LCNS_EL_CNT___PROGRAM1,s_element_nodes_PROGRAM1,0 },
{ sizeof(RTTypeNS_TypeNode),"LAUFLICHT",LCNS_EL_CNT___LAUFLICHT,s_element_nodes_LAUFLICHT,0 },
{ sizeof(RTTypeNS_TypeNode),"RS",LCNS_EL_CNT___RS,s_element_nodes_RS,0 },
{ sizeof(RTTypeNS_TypeNode),"R_TRIG",LCNS_EL_CNT___R_TRIG,s_element_nodes_R_TRIG,0 },
{ sizeof(RTTypeNS_TypeNode),"TON",LCNS_EL_CNT___TON,s_element_nodes_TON,0 },
{ sizeof(RTTypeNS_TypeNode),"VAR_GLOBAL",LCNS_EL_CNT___VAR_GLOBAL,s_element_nodes_VAR_GLOBAL,0 }
};

static const RTTypeNS_InstanceNode s_instance_nodes[] = {
   { sizeof(RTTypeNS_InstanceNode),"PROGRAM1",256,LCOOS_VAREXP_PRG_INST,LCNS_TNREF___PROGRAM1,0 },
   { sizeof(RTTypeNS_InstanceNode),"VAR_GLOBAL",2,LCOOS_VAREXP_PRG_INST,LCNS_TNREF___VAR_GLOBAL,0 }
};


int ns_get_typecount(void)
{
  return ARR_EL_CNT(s_type_nodes);
}

RTTypeNS_TypeNode const* ns_get_types(void)
{
  return s_type_nodes;
}

int ns_get_instancecount(void)
{
  return ARR_EL_CNT(s_instance_nodes);
}

RTTypeNS_InstanceNode const* ns_get_instances(void)
{
  return s_instance_nodes;
}

static const RTNameResolvingData3 global_NameserverData3 =
{
 {sizeof(RTNameResolvingData3),RTS_NS_STRUCT_VER_TypeNS,RTS_NS_FLAG_SUPPORT_ARRAY}
,LC_NS_TIMESTAMP
,ARR_EL_CNT(s_instance_nodes),s_instance_nodes
,ARR_EL_CNT(s_type_nodes),s_type_nodes
};

/* Generic I/O Data */
static const RTSS_IO_Generic_Config global_GenericIO =
{2,28,0};

/* Retained Data Information */
static const unsigned long global_RetainedDataVersion = 4294967295UL;

static const unsigned long global_fingerprint =
#include <Fingerprint.inc>
;

static char const global_codeImgMd[] =
#include <CodeImgMd.inc>
;
